web/router.ex
defmodule Auction.Router do
  use Auction.Web, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  pipeline :api do
    plug :accepts, ["json"]
  end

  scope "/", Auction do
    pipe_through :browser # Use the default browser stack

    resources "/auction", AuctionController, only: [:index, :show]
    get "/", PageController, :index
  end

  # Other scopes may use custom stacks.
  # scope "/api", Auction do
  #   pipe_through :api
  # end
end

lib/auction/endpoint.ex
defmodule Auction.Endpoint do
  use Phoenix.Endpoint, otp_app: :auction

  socket "/socket", Auction.UserSocket

  # Serve at "/" the static files from "priv/static" directory.
  #
  # You should set gzip to true if you are running phoenix.digest
  # when deploying your static files in production.
  plug Plug.Static,
    at: "/", from: :auction, gzip: false,
    only: ~w(css fonts images js favicon.ico robots.txt)

  # Code reloading can be explicitly enabled under the
  # :code_reloader configuration of your endpoint.
  if code_reloading? do
    socket "/phoenix/live_reload/socket", Phoenix.LiveReloader.Socket
    plug Phoenix.LiveReloader
    plug Phoenix.CodeReloader
  end

  plug Plug.RequestId
  plug Plug.Logger

  plug Plug.Parsers,
    parsers: [:urlencoded, :multipart, :json],
    pass: ["*/*"],
    json_decoder: Poison

  plug Plug.MethodOverride
  plug Plug.Head

  # The session will be stored in the cookie and signed,
  # this means its contents can be read but not tampered with.
  # Set :encryption_salt if you would also like to encrypt it.
  plug Plug.Session,
    store: :cookie,
    key: "_auction_key",
    signing_salt: "pavAujcu"

  plug Auction.Router
end

lib/auction/repo.ex
defmodule Auction.Repo do
  use Ecto.Repo, otp_app: :auction
end

web/models/item.ex
defmodule Auction.Item do
  use Auction.Web, :model

  schema "items" do
    field :name, :string
    field :size, :string
    field :price, :string

    timestamps()
  end

  @doc """
  Builds a changeset based on the `struct` and `params`.
  """
  def changeset(struct, params \\ %{}) do
    struct
    |> cast(params, [:name, :size, :price])
    |> validate_required([:name, :size, :price])
  end
end

web/models/user.ex
defmodule Auction.User do
  use Auction.Web, :model

  schema "users" do
    field :username, :string
    field :password, :string

    timestamps()
  end

  @doc """
  Builds a changeset based on the `struct` and `params`.
  """
  def changeset(struct, params \\ %{}) do
    struct
    |> cast(params, [:username, :password])
    |> validate_required([:username, :password])
  end
end

web/controllers/auction_controller.ex
defmodule Auction.AuctionController do
    use Auction.Web, :controller
  
    alias Auction.Item
    def index(conn, _params) do
      items = Repo.all(Item)
      render conn, "index.html", items: items
    end

    def show(conn, %{"id" => id}) do
        item = Repo.get!(Item, id)
        render(conn, "show.html", item: item)
      end
  end

web/controllers/page_controller.ex
defmodule Auction.PageController do
  use Auction.Web, :controller

  def index(conn, _params) do
    render conn, "index.html"
  end
end

web/views/auction_view.ex
defmodule Auction.AuctionView do
    use Auction.Web, :view
  end

web/views/error_view.ex
defmodule Auction.ErrorView do
  use Auction.Web, :view

  def render("404.html", _assigns) do
    "Page not found"
  end

  def render("500.html", _assigns) do
    "Internal server error"
  end

  # In case no render clause matches or no
  # template is found, let's render it as 500
  def template_not_found(_template, assigns) do
    render "500.html", assigns
  end
end

web/views/layout_view.ex
defmodule Auction.LayoutView do
  use Auction.Web, :view
end

web/views/page_view.ex
defmodule Auction.PageView do
  use Auction.Web, :view
end

web/templates/auction/index.html.eex
<h2>Listing items</h2>

<table class="table">
  <thead>
    <tr>
      <th>Name</th>
      <th>Size</th>
      <th>Current prize</th>
    </tr>
  </thead>
  <tbody>
<%= for item <- @items do %>
    <tr>
      <td><%= item.name %></td>
      <td><%= item.size %></td>
      <td><%= item.price %></td>
       <td class="text-right">
        <span><%= link "Show", to: auction_path(@conn, :show, item), class: "btn btn-default btn-xs" %></span>
      </td>
    </tr>
<% end %>
  </tbody>
</table>

web/templates/auction/show.html.eex
<h2>Show item</h2>

<ul>

  <li>
    <strong>Name:</strong>
    <%= @item.name %>
  </li>

  <li>
    <strong>Size:</strong>
    <%= @item.size %>
  </li>

  <li>
    <strong>Current price:</strong>
    <%= @item.price %>
  </li>

</ul>

<span><%= link "Back", to: auction_path(@conn, :index) %></span>

web/templates/layout/app.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Hello Auction!</title>
    <link rel="stylesheet" href="<%= static_path(@conn, "/css/app.css") %>">
  </head>

  <body>
    <div class="container">
      <header class="header">
        <nav role="navigation">
          <ul class="nav nav-pills pull-right">
            <li><a href="http://www.phoenixframework.org/docs">Get Started</a></li>
          </ul>
        </nav>
        <span class="logo"></span>
      </header>

      <p class="alert alert-info" role="alert"><%= get_flash(@conn, :info) %></p>
      <p class="alert alert-danger" role="alert"><%= get_flash(@conn, :error) %></p>

      <main role="main">
        <%= render @view_module, @view_template, assigns %>
      </main>

    </div> <!-- /container -->
    <script src="<%= static_path(@conn, "/js/app.js") %>"></script>
  </body>
</html>

web/templates/page/index.html.eex
<div class="jumbotron">
  <h2><%= gettext "Welcome to %{name}", name: "Phoenix!" %></h2>
  <p class="lead">A productive web framework that<br />does not compromise speed and maintainability.</p>
</div>

<div class="row marketing">
  <div class="col-lg-6">
    <h4>Resources</h4>
    <ul>
      <li>
        <a href="http://phoenixframework.org/docs/overview">Guides</a>
      </li>
      <li>
        <a href="https://hexdocs.pm/phoenix">Docs</a>
      </li>
      <li>
        <a href="https://github.com/phoenixframework/phoenix">Source</a>
      </li>
    </ul>
  </div>

  <div class="col-lg-6">
    <h4>Help</h4>
    <ul>
      <li>
        <a href="http://groups.google.com/group/phoenix-talk">Mailing list</a>
      </li>
      <li>
        <a href="http://webchat.freenode.net/?channels=elixir-lang">#elixir-lang on freenode IRC</a>
      </li>
      <li>
        <a href="https://twitter.com/elixirphoenix">@elixirphoenix</a>
      </li>
    </ul>
  </div>
</div>